#!/bin/sh

function mklist() {
    local name="$1"
    local lcname=$(echo $name | tr "A-Z" "a-z")

    echo "/* --- ${name} --- */"
    echo "static const char *${lcname}_names[] = {"
    grep -e "#define[ \t]\+${name}_[a-zA-u0-9]\+[ \t]\+[0-9]\+" \
		/usr/include/xen/*.h \
	| awk '{printf "    [ %-32s ] = \"%s\", \n", $2, $2 }' \
	| sed -e "s/\"${name}_/\"/"
    echo "};"
    echo
}

cat <<EOF
/*
 * don't edit, generated by $0
 */

#include <xen/version.h>
#include <xen/sched.h>
#include <xen/memory.h>
#include <xen/nmi.h>
#include <xen/callback.h>
#include <xen/physdev.h>
#include <xen/vcpu.h>
#include <xen/grant_table.h>

EOF

mklist __HYPERVISOR
#mklist XENVER
#mklist VMASST_TYPE
#mklist VMASST_CMD
mklist SCHEDOP
mklist CONSOLEIO
mklist XENMEM
#mklist XENNMI
mklist CALLBACKOP
mklist CALLBACKTYPE
mklist MMUEXT
#mklist PHYSDEVOP
mklist VCPUOP
mklist EVTCHNOP
mklist VIRQ
#mklist GNTTABOP